//+------------------------------------------------------------------+
//|                                                    CCIFilter.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                                                Written by nnjeim |   
//|                                                                  |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -0.05
#property indicator_maximum 1.05
#property indicator_buffers 4
#property indicator_color1 MediumBlue
#property indicator_color2 Crimson
#property indicator_color3 LightBlue
#property indicator_color4 Orange



//---- input parameters
extern int PeriodCCI=50;
extern int UpperTriggerLevel=100;
extern int LowerTriggerLevel=-100;
extern int AlertON=1;
//---- indicator buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double alertTag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,2);
   
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexBuffer(2,UpBuffer2);
   SetIndexBuffer(3,DnBuffer2);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="CCI Filter("+PeriodCCI+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
   SetIndexLabel(2,"Mild UpTrend");
   SetIndexLabel(3,"Mild DownTrend");
   
//----
   SetIndexDrawBegin(0,PeriodCCI);
   SetIndexDrawBegin(1,PeriodCCI);
   SetIndexDrawBegin(2,PeriodCCI);
   SetIndexDrawBegin(3,PeriodCCI);  
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| CCIFilter                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int shift,trend;
   double CCI0;

   
   for(shift=Bars-PeriodCCI-1;shift>=0;shift--)
   {	
   CCI0=iCCI(NULL,0,PeriodCCI,PRICE_CLOSE,shift);
   	
	  if (CCI0>0 && CCI0<UpperTriggerLevel)  trend=1;
	  if (CCI0>UpperTriggerLevel)  trend=2;  
	  if (CCI0<0 && CCI0>LowerTriggerLevel) trend=-1;
	  if (CCI0<LowerTriggerLevel)  trend=-2;
	  
	  if (trend==1) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=1;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  if(AlertON==1 && alertTag!=Time[0]) {Alert("Mild UP Trend ",Symbol()," Period ",Period());alertTag = Time[0];}
	  }
	  if (trend==2) 
	  {
	  
	  UpBuffer1[shift]=1;
	  UpBuffer2[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  if(AlertON==1 && alertTag!=Time[0]) {Alert("UP Trend ",Symbol()," Period ",Period());alertTag = Time[0];}
	  
	  }
	  if (trend==-1) 
	  {
	   
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=1;
	  if(AlertON==1 && alertTag!=Time[0]) {Alert("Mild Down Trend ",Symbol()," Period ",Period());alertTag = Time[0];}
	  }
	  
	  if (trend==-2) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  DnBuffer1[shift]=1;
	  DnBuffer2[shift]=0;
	  if(AlertON==1 && alertTag!=Time[0]) {Alert("Down Trend ",Symbol()," Period ",Period());alertTag = Time[0];} 
	  
	  }
	}
	return(0);	
 }

